Zenario
==========

What is Zenario?
-------------------

Zenario is a web-based **content management system**, or CMS. It can be used for simple
sites, with many "wysiwyg" features, and it is well suited for **extranet** sites,
such as customer portals. It also has **multilingual** features built in from the core.

* Zenario's [Official website](https://zenar.io)

What are the main features?
------------------------------

* **Free, open source** code (BSD license)

* Written in the popular open source PHP language and for the MySQL database

* **WYSIWYG** tools for easy content editing

* **Permissions system** for managing what administrators can do
 
* **Page versioning system** allows pages to be created, previewed, and published, and a history
  to be stored
 
* **Drag and drop** tools for setting up and modifying site menu navigation
 
* Support for HTML web pages, documents, blogs, news items, events, and other content types
 
* **Image optimisation** is automatic, so full-size images can be stored as JPG/PNG, while the client is served with a WebP or other optimised image

* Includes the **Gridmaker** tool for creating responsive layout designs by drag and drop

* **Extranet** user and contact management; full set of extranet features (login, register etc.)
 
* Powerful **Forms** feature, with which data can be captured and then emailed, merged with a
  contact's data, or sent to a CRM
 
* Data schemas for Users/contacts, Locations, Documents can be modified (adding fields) using
  Zenario's **Datasets** feature
 
* Many in-built **search-engine optimisation** features, such as XML sitemap, friendly URLs and more


Learn Zenario
--------------------------------------

* Watch our [videos](https://zenar.io/video-tutorials) to learn how to use Zenario.

* Access the [Zenario documentation area](https://zenar.io/documentation-area) to get
  technical help if you are a designer, or want to write your own modules.

* Can't find what you're looking for? Ask us in the [forum](https://zenar.io/forums).

* The Github repository is a public version of our private repository. We're currently not able
  to accept Pull requests to this repo.


Download Zenario
---------------------
* You can download a packaged version of Zenario in zip, gzip or 7zip format at
  [zenar.io/download-zenario](https://zenar.io/download-zenario)


