/*
 modernizr v3.12.0
 Build https://modernizr.com/download?-applicationcache-audio-blobconstructor-canvas-canvastext-cssanimations-csscolumns-cssgradients-cssreflections-csstransforms-csstransforms3d-csstransitions-geolocation-hashchange-history-indexeddb-input-inputtypes-localstorage-postmessage-sessionstorage-smil-svg-svgclippaths-video-webgl-websockets-websqldatabase-webworkers-addtest-domprefixes-hasevent-prefixed-prefixes-setclasses-testallprops-testprop-teststyles-dontmin

 Copyright (c)
  Faruk Ates
  Paul Irish
  Alex Sexton
  Ryan Seddon
  Patrick Kettner
  Stu Cox
  Richard Herrera
  Veeck

 MIT License
 {
  "name": "Application Cache",
  "property": "applicationcache",
  "caniuse": "offline-apps",
  "tags": ["storage", "offline"],
  "notes": [{
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/en/docs/HTML/Using_the_application_cache"
  }],
  "polyfills": ["html5gears"]
}
! {
  "name": "HTML5 Audio Element",
  "property": "audio",
  "caniuse": "audio",
  "tags": ["html5", "audio", "media"],
  "notes": [{
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/En/Media_formats_supported_by_the_audio_and_video_elements"
  }]
}
! {
  "name": "Blob constructor",
  "property": "blobconstructor",
  "aliases": ["blob-constructor"],
  "builderAliases": ["blob_constructor"],
  "caniuse": "blobbuilder",
  "notes": [{
    "name": "W3C Spec",
    "href": "https://w3c.github.io/FileAPI/#constructorBlob"
  }],
  "polyfills": ["blobjs"]
}
! {
  "name": "Canvas",
  "property": "canvas",
  "caniuse": "canvas",
  "tags": ["canvas", "graphics"],
  "polyfills": ["flashcanvas", "excanvas", "slcanvas", "fxcanvas"]
}
! {
  "name": "Canvas text",
  "property": "canvastext",
  "caniuse": "canvas-text",
  "tags": ["canvas", "graphics"],
  "polyfills": ["canvastext"]
}
! {
  "name": "CSS Animations",
  "property": "cssanimations",
  "caniuse": "css-animation",
  "polyfills": ["transformie", "csssandpaper"],
  "tags": ["css"],
  "warnings": ["Android < 4 will pass this test, but can only animate a single property at a time"],
  "notes": [{
    "name": "Article: 'Dispelling the Android CSS animation myths'",
    "href": "https://web.archive.org/web/20180602074607/https://daneden.me/2011/12/14/putting-up-with-androids-bullshit/"
  }]
}
! {
  "name": "CSS Columns",
  "property": "csscolumns",
  "caniuse": "multicolumn",
  "polyfills": ["css3multicolumnjs"],
  "tags": ["css"]
}
! {
  "name": "CSS Gradients",
  "caniuse": "css-gradients",
  "property": "cssgradients",
  "tags": ["css"],
  "knownBugs": ["False-positives on webOS (https://github.com/Modernizr/Modernizr/issues/202)"],
  "notes": [{
    "name": "Webkit Gradient Syntax",
    "href": "https://webkit.org/blog/175/introducing-css-gradients/"
  }, {
    "name": "Linear Gradient Syntax",
    "href": "https://developer.mozilla.org/en-US/docs/Web/CSS/linear-gradient"
  }, {
    "name": "W3C Spec",
    "href": "https://drafts.csswg.org/css-images-3/#gradients"
  }]
}
! {
  "name": "CSS Reflections",
  "caniuse": "css-reflections",
  "property": "cssreflections",
  "tags": ["css"]
}
! {
  "name": "CSS Transforms",
  "property": "csstransforms",
  "caniuse": "transforms2d",
  "tags": ["css"]
}
! {
  "name": "CSS Supports",
  "property": "supports",
  "caniuse": "css-featurequeries",
  "tags": ["css"],
  "builderAliases": ["css_supports"],
  "notes": [{
    "name": "W3C Spec (The @supports rule)",
    "href": "https://dev.w3.org/csswg/css3-conditional/#at-supports"
  }, {
    "name": "Related Github Issue",
    "href": "https://github.com/Modernizr/Modernizr/issues/648"
  }, {
    "name": "W3C Spec (The CSSSupportsRule interface)",
    "href": "https://dev.w3.org/csswg/css3-conditional/#the-csssupportsrule-interface"
  }]
}
! {
  "name": "CSS Transforms 3D",
  "property": "csstransforms3d",
  "caniuse": "transforms3d",
  "tags": ["css"],
  "warnings": [
    "Chrome may occasionally fail this test on some systems; more info: https://bugs.chromium.org/p/chromium/issues/detail?id=129004"
  ]
}
! {
  "name": "CSS Transitions",
  "property": "csstransitions",
  "caniuse": "css-transitions",
  "tags": ["css"]
}
! {
  "name": "Geolocation API",
  "property": "geolocation",
  "caniuse": "geolocation",
  "tags": ["media"],
  "notes": [{
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/en-US/docs/WebAPI/Using_geolocation"
  }],
  "polyfills": [
    "joshuabell-polyfill",
    "webshims",
    "geo-location-javascript",
    "geolocation-api-polyfill"
  ]
}
! {
  "name": "Hashchange event",
  "property": "hashchange",
  "caniuse": "hashchange",
  "tags": ["history"],
  "notes": [{
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/en-US/docs/Web/API/WindowEventHandlers/onhashchange"
  }],
  "polyfills": [
    "jquery-hashchange",
    "moo-historymanager",
    "jquery-ajaxy",
    "hasher",
    "shistory"
  ]
}
! {
  "name": "History API",
  "property": "history",
  "caniuse": "history",
  "tags": ["history"],
  "authors": ["Hay Kranen", "Alexander Farkas"],
  "notes": [{
    "name": "W3C Spec",
    "href": "https://www.w3.org/TR/html51/browsers.html#the-history-interface"
  }, {
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/en-US/docs/Web/API/window.history"
  }],
  "polyfills": ["historyjs", "html5historyapi"]
}
! {
  "name": "IndexedDB",
  "property": "indexeddb",
  "caniuse": "indexeddb",
  "tags": ["storage"],
  "polyfills": ["indexeddb"],
  "async": true
}
! {
  "name": "Input attributes",
  "property": "input",
  "tags": ["forms"],
  "authors": ["Mike Taylor"],
  "notes": [{
    "name": "WHATWG Spec",
    "href": "https://html.spec.whatwg.org/multipage/input.html#input-type-attr-summary"
  }],
  "knownBugs": ["Some blackberry devices report false positive for input.multiple"]
}
! {
  "name": "Form input types",
  "property": "inputtypes",
  "caniuse": "forms",
  "tags": ["forms"],
  "authors": ["Mike Taylor"],
  "polyfills": [
    "jquerytools",
    "webshims",
    "h5f",
    "webforms2",
    "nwxforms",
    "fdslider",
    "html5slider",
    "galleryhtml5forms",
    "jscolor",
    "html5formshim",
    "selectedoptionsjs",
    "formvalidationjs"
  ]
}
! {
  "name": "postMessage",
  "property": "postmessage",
  "caniuse": "x-doc-messaging",
  "notes": [{
    "name": "W3C Spec",
    "href": "https://www.w3.org/TR/webmessaging/#crossDocumentMessages"
  }],
  "polyfills": ["easyxdm", "postmessage-jquery"],
  "knownBugs": ["structuredclones - Android 2&3 can not send a structured clone of dates, filelists or regexps"],
  "warnings": ["Some old WebKit versions have bugs. Stick with object, array, number and pixeldata to be safe."]
}
! {
  "name": "Local Storage",
  "property": "localstorage",
  "caniuse": "namevalue-storage",
  "tags": ["storage"],
  "polyfills": [
    "joshuabell-polyfill",
    "cupcake",
    "storagepolyfill",
    "amplifyjs",
    "yui-cacheoffline"
  ]
}
! {
  "name": "Session Storage",
  "property": "sessionstorage",
  "tags": ["storage"],
  "polyfills": ["joshuabell-polyfill", "cupcake", "sessionstorage"]
}
! {
  "name": "Web SQL Database",
  "property": "websqldatabase",
  "caniuse": "sql-storage",
  "tags": ["storage"]
}
! {
  "name": "SVG",
  "property": "svg",
  "caniuse": "svg",
  "tags": ["svg"],
  "authors": ["Erik Dahlstrom"],
  "polyfills": [
    "svgweb",
    "raphael",
    "amplesdk",
    "canvg",
    "svg-boilerplate",
    "sie",
    "dojogfx",
    "fabricjs"
  ]
}
! {
  "name": "SVG clip paths",
  "property": "svgclippaths",
  "tags": ["svg"],
  "notes": [{
    "name": "Demo",
    "href": "http://srufaculty.sru.edu/david.dailey/svg/newstuff/clipPath4.svg"
  }]
}
! {
  "name": "SVG SMIL animation",
  "property": "smil",
  "caniuse": "svg-smil",
  "tags": ["svg"],
  "notes": [{
  "name": "W3C Spec",
  "href": "https://www.w3.org/AudioVideo/"
  }]
}
! {
  "name": "HTML5 Video",
  "property": "video",
  "caniuse": "video",
  "tags": ["html5", "video", "media"],
  "knownBugs": ["Without QuickTime, `Modernizr.video.h264` will be `undefined`; https://github.com/Modernizr/Modernizr/issues/546"],
  "polyfills": [
    "html5media",
    "mediaelementjs",
    "sublimevideo",
    "videojs",
    "leanbackplayer",
    "videoforeverybody"
  ]
}
! {
  "name": "WebGL",
  "property": "webgl",
  "caniuse": "webgl",
  "tags": ["webgl", "graphics"],
  "polyfills": ["jebgl", "cwebgl", "iewebgl"]
}
! {
  "name": "WebSockets Support",
  "property": "websockets",
  "authors": ["Phread (@fearphage)", "Mike Sherov (@mikesherov)", "Burak Yigit Kaya (@BYK)"],
  "caniuse": "websockets",
  "tags": ["html5"],
  "warnings": [
    "This test will reject any old version of WebSockets even if it is not prefixed such as in Safari 5.1"
  ],
  "notes": [{
    "name": "CLOSING State and Spec",
    "href": "https://www.w3.org/TR/websockets/#the-websocket-interface"
  }],
  "polyfills": [
    "sockjs",
    "socketio",
    "kaazing-websocket-gateway",
    "websocketjs",
    "atmosphere",
    "graceful-websocket",
    "portal",
    "datachannel"
  ]
}
! {
  "name": "Web Workers",
  "property": "webworkers",
  "caniuse": "webworkers",
  "tags": ["performance", "workers"],
  "notes": [{
    "name": "W3C Spec",
    "href": "https://www.w3.org/TR/workers/"
  }, {
    "name": "HTML5 Rocks Tutorial",
    "href": "https://www.html5rocks.com/en/tutorials/workers/basics/"
  }, {
    "name": "MDN Docs",
    "href": "https://developer.mozilla.org/en-US/docs/Web/API/Web_Workers_API/Using_web_workers"
  }],
  "polyfills": ["fakeworker", "html5shims"]
}
!*/
(function(U,h,l,u){function q(a,b){return typeof a===b}function F(a){var b=p.className,c=d._config.classPrefix||"";C&&(b=b.baseVal);d._config.enableJSClass&&(b=b.replace(new RegExp("(^|\\s)"+c+"no-js(\\s|$)"),"$1"+c+"js$2"));d._config.enableClasses&&(0<a.length&&(b+=" "+c+a.join(" "+c)),C?p.className.baseVal=b:p.className=b)}function v(a,b){if("object"===typeof a)for(var c in a)G(a,c)&&v(c,a[c]);else{a=a.toLowerCase();c=a.split(".");var e=d[c[0]];2===c.length&&(e=e[c[1]]);if("undefined"!==typeof e)return d;
b="function"===typeof b?b():b;1===c.length?d[c[0]]=b:(!d[c[0]]||d[c[0]]instanceof Boolean||(d[c[0]]=new Boolean(d[c[0]])),d[c[0]][c[1]]=b);F([(b&&!1!==b?"":"no-")+c.join("-")]);d._trigger(a,b)}return d}function m(){return"function"!==typeof l.createElement?l.createElement(arguments[0]):C?l.createElementNS.call(l,"http://www.w3.org/2000/svg",arguments[0]):l.createElement.apply(l,arguments)}function H(a,b,c,e){var f=m("div");var g=l.body;g||(g=m(C?"svg":"body"),g.fake=!0);if(parseInt(c,10))for(;c--;){var w=
m("div");w.id=e?e[c]:"modernizr"+(c+1);f.appendChild(w)}c=m("style");c.type="text/css";c.id="smodernizr";(g.fake?g:f).appendChild(c);g.appendChild(f);c.styleSheet?c.styleSheet.cssText=a:c.appendChild(l.createTextNode(a));f.id="modernizr";if(g.fake){g.style.background="";g.style.overflow="hidden";var r=p.style.overflow;p.style.overflow="hidden";p.appendChild(g)}a=b(f,a);g.fake&&g.parentNode?(g.parentNode.removeChild(g),p.style.overflow=r,p.offsetHeight):f.parentNode.removeChild(f);return!!a}function I(a){return a.replace(/([A-Z])/g,
function(b,c){return"-"+c.toLowerCase()}).replace(/^ms-/,"-ms-")}function V(a,b){var c=a.length;if("CSS"in h&&"supports"in h.CSS){for(;c--;)if(h.CSS.supports(I(a[c]),b))return!0;return!1}if("CSSSupportsRule"in h){for(var e=[];c--;)e.push("("+I(a[c])+":"+b+")");e=e.join(" or ");return H("@supports ("+e+") { #modernizr { position: absolute; } }",function(f){if("getComputedStyle"in h){f=getComputedStyle.call(h,f,null);var g=h.console;null!==f?f=f.getPropertyValue("position"):g&&g[g.error?"error":"log"].call(g,
"getComputedStyle returning null, its possible modernizr test results are inaccurate")}else f=f.currentStyle&&f.currentStyle.position;return"absolute"===f})}return u}function J(a){return a.replace(/([a-z])-([a-z])/g,function(b,c,e){return c+e.toUpperCase()}).replace(/^-/,"")}function K(a,b,c,e){function f(){w&&(delete t.style,delete t.modElem)}e=q(e,"undefined")?!1:e;if(!q(c,"undefined")){var g=V(a,c);if(!q(g,"undefined"))return g}for(g=["modernizr","tspan","samp"];!t.style&&g.length;){var w=!0;t.modElem=
m(g.shift());t.style=t.modElem.style}var r=a.length;for(g=0;g<r;g++){var x=a[g];var W=t.style[x];~(""+x).indexOf("-")&&(x=J(x));if(t.style[x]!==u){if(e||q(c,"undefined"))return f(),"pfx"===b?x:!0;try{t.style[x]=c}catch(Z){}if(t.style[x]!==W)return f(),"pfx"===b?x:!0}}f();return!1}function X(a,b){return function(){return a.apply(b,arguments)}}function D(a,b,c,e,f){var g=a.charAt(0).toUpperCase()+a.slice(1),w=(a+" "+L.join(g+" ")+g).split(" ");if(q(b,"string")||q(b,"undefined"))return K(w,b,e,f);w=
(a+" "+M.join(g+" ")+g).split(" ");a:{a=w;for(var r in a)if(a[r]in b){if(!1===c){b=a[r];break a}r=b[a[r]];if(q(r,"function")){b=X(r,c||b);break a}b=r;break a}b=!1}return b}function y(a,b,c){return D(a,u,u,b,c)}function N(a,b){a=a.deleteDatabase(b);a.onsuccess=function(){v("indexeddb.deletedatabase",!0)};a.onerror=function(){v("indexeddb.deletedatabase",!1)}}var A=[],k={_version:"3.12.0",_config:{classPrefix:"",enableClasses:!0,enableJSClass:!0,usePrefixes:!0},_q:[],on:function(a,b){var c=this;setTimeout(function(){b(c[a])},
0)},addTest:function(a,b,c){A.push({name:a,fn:b,options:c})},addAsyncTest:function(a){A.push({name:null,fn:a})}},d=function(){};d.prototype=k;d=new d;var O=[],p=l.documentElement,C="svg"===p.nodeName.toLowerCase(),G;(function(){var a={}.hasOwnProperty;G=q(a,"undefined")||q(a.call,"undefined")?function(b,c){return c in b&&q(b.constructor.prototype[c],"undefined")}:function(b,c){return a.call(b,c)}})();k._l={};k.on=function(a,b){this._l[a]||(this._l[a]=[]);this._l[a].push(b);d.hasOwnProperty(a)&&setTimeout(function(){d._trigger(a,
d[a])},0)};k._trigger=function(a,b){if(this._l[a]){var c=this._l[a];setTimeout(function(){var e;for(e=0;e<c.length;e++){var f=c[e];f(b)}},0);delete this._l[a]}};d._q.push(function(){k.addTest=v});var M=k._config.usePrefixes?["moz","o","ms","webkit"]:[];k._domPrefixes=M;var P=function(){var a=!("onblur"in p);return function(b,c){if(!b)return!1;c&&"string"!==typeof c||(c=m(c||"div"));b="on"+b;var e=b in c;!e&&a&&(c.setAttribute||(c=m("div")),c.setAttribute(b,""),e="function"===typeof c[b],c[b]!==u&&
(c[b]=u),c.removeAttribute(b));return e}}();k.hasEvent=P;var L=k._config.usePrefixes?["Moz","O","ms","Webkit"]:[];k._cssomPrefixes=L;var Q={elem:m("modernizr")};d._q.push(function(){delete Q.elem});var t={style:Q.elem.style};d._q.unshift(function(){delete t.style});k.testAllProps=D;var R=function(a){var b=B.length,c=h.CSSRule;if("undefined"===typeof c)return u;if(!a)return!1;a=a.replace(/^@/,"");var e=a.replace(/-/g,"_").toUpperCase()+"_RULE";if(e in c)return"@"+a;for(var f=0;f<b;f++){var g=B[f];
if(g.toUpperCase()+"_"+e in c)return"@-"+g.toLowerCase()+"-"+a}return!1};k.atRule=R;var Y=k.prefixed=function(a,b,c){if(0===a.indexOf("@"))return R(a);-1!==a.indexOf("-")&&(a=J(a));return b?D(a,b,c):D(a,"pfx")},B=k._config.usePrefixes?" -webkit- -moz- -o- -ms- ".split(" "):["",""];k._prefixes=B;k.testAllProps=y;k.testProp=function(a,b,c){return K([a],u,b,c)};k.testStyles=H;d.addTest("applicationcache","applicationCache"in h);(function(){var a=m("audio");d.addTest("audio",function(){var b=!1;try{(b=
!!a.canPlayType)&&(b=new Boolean(b))}catch(c){}return b});try{a.canPlayType&&(d.addTest("audio.ogg",a.canPlayType('audio/ogg; codecs="vorbis"').replace(/^no$/,"")),d.addTest("audio.mp3",a.canPlayType('audio/mpeg; codecs="mp3"').replace(/^no$/,"")),d.addTest("audio.opus",a.canPlayType('audio/ogg; codecs="opus"')||a.canPlayType('audio/webm; codecs="opus"').replace(/^no$/,"")),d.addTest("audio.wav",a.canPlayType('audio/wav; codecs="1"').replace(/^no$/,"")),d.addTest("audio.m4a",(a.canPlayType("audio/x-m4a;")||
a.canPlayType("audio/aac;")).replace(/^no$/,"")))}catch(b){}})();d.addTest("blobconstructor",function(){try{return!!new Blob}catch(a){return!1}},{aliases:["blob-constructor"]});d.addTest("canvas",function(){var a=m("canvas");return!(!a.getContext||!a.getContext("2d"))});d.addTest("canvastext",function(){return!1===d.canvas?!1:"function"===typeof m("canvas").getContext("2d").fillText});d.addTest("cssanimations",y("animationName","a",!0));(function(){d.addTest("csscolumns",function(){var f=!1,g=y("columnCount");
try{(f=!!g)&&(f=new Boolean(f))}catch(w){}return f});for(var a="Width Span Fill Gap Rule RuleColor RuleStyle RuleWidth BreakBefore BreakAfter BreakInside".split(" "),b,c,e=0;e<a.length;e++){b=a[e].toLowerCase();c=y("column"+a[e]);if("breakbefore"===b||"breakafter"===b||"breakinside"===b)c=c||y(a[e]);d.addTest("csscolumns."+b,c)}})();d.addTest("cssgradients",function(){for(var a="",b,c=0,e=B.length-1;c<e;c++)b=0===c?"to ":"",a+="background-image:"+B[c]+"linear-gradient("+b+"left top, #9f9, white);";
d._config.usePrefixes&&(a+="background-image:-webkit-gradient(linear,left top,right bottom,from(#9f9),to(white));");b=m("a").style;b.cssText=a;return-1<(""+b.backgroundImage).indexOf("gradient")});d.addTest("cssreflections",y("boxReflect","above",!0));d.addTest("csstransforms",function(){return-1===navigator.userAgent.indexOf("Android 2.")&&y("transform","scale(1)",!0)});d.addTest("supports","CSS"in h&&"supports"in h.CSS||"supportsCSS"in h);d.addTest("csstransforms3d",function(){return!!y("perspective",
"1px",!0)});d.addTest("csstransitions",y("transition","all",!0));d.addTest("geolocation","geolocation"in navigator);d.addTest("hashchange",function(){return!1===P("hashchange",h)?!1:l.documentMode===u||7<l.documentMode});d.addTest("history",function(){var a=navigator.userAgent;return a&&(-1===a.indexOf("Android 2.")&&-1===a.indexOf("Android 4.0")||-1===a.indexOf("Mobile Safari")||-1!==a.indexOf("Chrome")||-1!==a.indexOf("Windows Phone")||"file:"===location.protocol)?h.history&&"pushState"in h.history:
!1});d.addAsyncTest(function(){try{var a=Y("indexedDB",h)}catch(e){}if(a){var b="modernizr-"+Math.random();try{var c=a.open(b)}catch(e){v("indexeddb",!1);return}c.onerror=function(e){!c.error||"InvalidStateError"!==c.error.name&&"UnknownError"!==c.error.name?(v("indexeddb",!0),N(a,b)):(v("indexeddb",!1),e.preventDefault())};c.onsuccess=function(){v("indexeddb",!0);N(a,b)}}else v("indexeddb",!1)});var n=m("input"),E={};d.input=function(a){for(var b=0,c=a.length;b<c;b++)E[a[b]]=!!(a[b]in n);E.list&&
(E.list=!(!m("datalist")||!h.HTMLDataListElement));return E}("autocomplete autofocus list placeholder max min multiple pattern required step".split(" "));(function(){for(var a="search tel url email datetime date month week time datetime-local number range color".split(" "),b,c,e=0;e<a.length;e++){n.setAttribute("type",b=a[e]);if(c="text"!==n.type&&"style"in n)n.value="1)",n.style.cssText="position:absolute;visibility:hidden;",/^range$/.test(b)&&n.style.WebkitAppearance!==u?(p.appendChild(n),c=l.defaultView,
c=c.getComputedStyle&&"textfield"!==c.getComputedStyle(n,null).WebkitAppearance&&0!==n.offsetHeight,p.removeChild(n)):/^(search|tel)$/.test(b)||(c=/^(url|email)$/.test(b)?n.checkValidity&&!1===n.checkValidity():"1)"!==n.value);d.addTest("inputtypes."+b,!!c)}})();var S=!0;try{h.postMessage({toString:function(){S=!1}},"*")}catch(a){}d.addTest("postmessage",new Boolean("postMessage"in h));d.addTest("postmessage.structuredclones",S);d.addTest("localstorage",function(){try{return localStorage.setItem("modernizr",
"modernizr"),localStorage.removeItem("modernizr"),!0}catch(a){return!1}});d.addTest("sessionstorage",function(){try{return sessionStorage.setItem("modernizr","modernizr"),sessionStorage.removeItem("modernizr"),!0}catch(a){return!1}});d.addTest("websqldatabase","openDatabase"in h);d.addTest("svg",!!l.createElementNS&&!!l.createElementNS("http://www.w3.org/2000/svg","svg").createSVGRect);var T={}.toString;d.addTest("svgclippaths",function(){return!!l.createElementNS&&/SVGClipPath/.test(T.call(l.createElementNS("http://www.w3.org/2000/svg",
"clipPath")))});d.addTest("smil",function(){return!!l.createElementNS&&/SVGAnimate/.test(T.call(l.createElementNS("http://www.w3.org/2000/svg","animate")))});(function(){var a=m("video");d.addTest("video",function(){var b=!1;try{(b=!!a.canPlayType)&&(b=new Boolean(b))}catch(c){}return b});try{a.canPlayType&&(d.addTest("video.ogg",a.canPlayType('video/ogg; codecs="theora"').replace(/^no$/,"")),d.addTest("video.h264",a.canPlayType('video/mp4; codecs="avc1.42E01E"').replace(/^no$/,"")),d.addTest("video.h265",
a.canPlayType('video/mp4; codecs="hev1"').replace(/^no$/,"")),d.addTest("video.webm",a.canPlayType('video/webm; codecs="vp8, vorbis"').replace(/^no$/,"")),d.addTest("video.vp9",a.canPlayType('video/webm; codecs="vp9"').replace(/^no$/,"")),d.addTest("video.hls",a.canPlayType('application/x-mpegURL; codecs="avc1.42E01E"').replace(/^no$/,"")),d.addTest("video.av1",a.canPlayType('video/mp4; codecs="av01"').replace(/^no$/,"")))}catch(b){}})();d.addTest("webgl",function(){return"WebGLRenderingContext"in
h});var z=!1;try{z="WebSocket"in h&&2===h.WebSocket.CLOSING}catch(a){}d.addTest("websockets",z);d.addTest("webworkers","Worker"in h);(function(){var a,b;for(b in A)if(A.hasOwnProperty(b)){var c=[];var e=A[b];if(e.name&&(c.push(e.name.toLowerCase()),e.options&&e.options.aliases&&e.options.aliases.length))for(a=0;a<e.options.aliases.length;a++)c.push(e.options.aliases[a].toLowerCase());e=q(e.fn,"function")?e.fn():e.fn;for(a=0;a<c.length;a++){var f=c[a];f=f.split(".");1===f.length?d[f[0]]=e:(d[f[0]]&&
(!d[f[0]]||d[f[0]]instanceof Boolean)||(d[f[0]]=new Boolean(d[f[0]])),d[f[0]][f[1]]=e);O.push((e?"":"no-")+f.join("-"))}}})();F(O);delete k.addTest;delete k.addAsyncTest;for(z=0;z<d._q.length;z++)d._q[z]();U.Modernizr=d})(window,window,document);
